"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
require('es6-promise').polyfill();
require('isomorphic-fetch');
var GqlClient = (function () {
    function GqlClient(options) {
        if (options) {
            this.setOptions(options);
        }
    }
    Object.defineProperty(GqlClient.prototype, "headers", {
        get: function () {
            return this._headers;
        },
        set: function (value) {
            this._headers = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GqlClient.prototype, "token", {
        get: function () {
            return this._token;
        },
        set: function (value) {
            this._token = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GqlClient.prototype, "url", {
        get: function () {
            return this._url;
        },
        set: function (value) {
            this._url = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GqlClient.prototype, "query", {
        get: function () {
            return this._query;
        },
        set: function (value) {
            this._query = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GqlClient.prototype, "variables", {
        get: function () {
            return this._variables;
        },
        set: function (value) {
            this._variables = value;
        },
        enumerable: true,
        configurable: true
    });
    GqlClient.prototype.prepareVariables = function () {
        return {
            operationName: null,
            query: this.query,
            variables: this.variables
        };
    };
    GqlClient.prototype.setOptions = function (options) {
        this.token = options.token;
        this.url = options.url;
        this.query = options.query;
        this.variables = options.variables;
        return this;
    };
    GqlClient.prototype.send = function (variables) {
        var _this = this;
        if (variables) {
            this.variables = variables;
        }
        if (!this.url)
            throw "url not found";
        var headers = {
            'Content-Type': 'application/json'
        };
        if (this.token) {
            headers['Authorization'] = 'Bearer ' + this.token;
        }
        if (this.headers) {
            headers = tslib_1.__assign({}, headers, this.headers);
        }
        var fb = {
            method: 'POST',
            body: JSON.stringify(this.prepareVariables()),
            headers: headers
        };
        return fetch(this.url, fb).then(function (response) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = [{}];
                        return [4, response.json()];
                    case 1: return [2, tslib_1.__assign.apply(void 0, _a.concat([_b.sent(),
                            {
                                status: response.status,
                                statusText: response.statusText,
                                headers: response.headers
                            }]))];
                }
            });
        }); }).then(function (res) {
            return res;
        });
    };
    return GqlClient;
}());
exports.GqlClient = GqlClient;
